/* 
 * pdal_defines.h.in is used by cmake to generate pdal_defines.h
 *
 * Do not edit pdal_defines.h!
 *
 * Note this is a C-style header.  Do not use C++ syntax.
 */
#ifndef PDAL_DEFINES_H
#define PDAL_DEFINES_H

/*
 * version settings
 */
#define PDAL_VERSION_MAJOR 0
#define PDAL_VERSION_MINOR 8
#define PDAL_VERSION_PATCH 6

#define PDAL_VERSION_STRING "0.8.6"

/* (note this will look yucky until we get to major>=1) */
#define PDAL_VERSION_INTEGER ((PDAL_VERSION_MAJOR*100*100)+(PDAL_VERSION_MINOR*100)+PDAL_VERSION_PATCH)


/*
 * availability of 3rd-party libraries
 */
/* #undef PDAL_HAVE_CARIS */
/* #undef PDAL_HAVE_GEOS */
#define PDAL_HAVE_GDAL
#define PDAL_HAVE_HEXER
/* #undef PDAL_HAVE_FLANN */
#define PDAL_HAVE_LASZIP
#define PDAL_HAVE_LIBXML2
#define PDAL_HAVE_LIBGEOTIFF
/* #undef PDAL_HAVE_MRSID */
#define PDAL_HAVE_NITRO
#define PDAL_HAVE_ORACLE
/* #undef PDAL_HAVE_P2G */
#define PDAL_HAVE_PYTHON
/* #undef PDAL_HAVE_SOCI */
/* #undef PDAL_HAVE_POSTGRESQL */

/* 
 * plugins
 */
/* #undef USE_PDAL_PLUGIN_PCD */
/* #undef USE_PDAL_PLUGIN_TEXT */
/* #undef USE_PDAL_PLUGIN_SOCI */
/* #undef USE_PDAL_PLUGIN_OCI */
/* #undef USE_PDAL_PLUGIN_MRSID */
/* #undef USE_PDAL_PLUGIN_CARIS */
/* #undef USE_PDAL_PLUGIN_PGPOINTCLOUD */


/*
 * platform endianness
 */
/* #undef PDAL_ENDIAN_AWARE */

/*
 * Debug or Release build?
 */
#define PDAL_BUILD_TYPE "Release"

/*
 * platform OS
 */
#define PDAL_PLATFORM_WIN32

/*
 * platform compiler 
 */
#define PDAL_COMPILER_MSVC

/*
 * Use the embedded boost tree instead of system one 
 */
#define PDAL_EMBED_BOOST

#define PDAL_COMPILER_VC10
/* #undef PDAL_COMPILER_VC9 */
/* #undef PDAL_COMPILER_VC8 */
/* #undef PDAL_COMPILER_GCC */
/* #undef PDAL_COMPILER_CLANG */


/*
 * We have two modes: with GDAL and geotiff, SRS is enabled -- otherwise, it's disabled
 * we use one macro to simplify the control
 */
#if defined(PDAL_HAVE_GDAL) && defined(PDAL_HAVE_LIBGEOTIFF)
#define PDAL_SRS_ENABLED
#endif

#endif
